diff -urN ifmail-2.15dev5-al1/ifgate/message.c ifmail-2.15dev5-al1.transit/ifgate/message.c
--- ifmail-2.15dev5-al1/ifgate/message.c	2004-07-19 18:47:30.000000000 +0300
+++ ifmail-2.15dev5-al1.transit/ifgate/message.c	2004-09-01 19:19:50.000000000 +0300
@@ -35,6 +35,7 @@
 static int removeorg;
 static int removeref;
 static int ftnorigin;
+int f_transit;
 
 static int isftnpath(char*);
 
@@ -130,12 +131,13 @@
 	 * because it has different (converted from MSGID) Message-ID.
 	 * Therefore, we need ^ARFC-Message-ID.
 	 */
-	if (!strcasecmp(msg->key,"Message-ID")) return ftnorigin?0:1;
+	if (!strcasecmp(msg->key,"Message-ID")) return ftnorigin?0:(f_transit?1:0);
 	/* References are good for threaded newsreaders */
 	if (!strcasecmp(msg->key,"References")) return removeref?0:1;
 	if (!strcasecmp(msg->key,"Distribution")) return 0; /*ftnorigin?0:1;*/
 	/*if (!strcasecmp(msg->key,"")) return ;*/
 	return 0; /*1;*/
+//	return f_transit?1:0; /*1;*/
 }
 
 /* in real life, this never happens...  I probably should drop it... */
@@ -226,6 +228,7 @@
 	int i;
 	char sbe[16];
 	FILE *pkt;
+	char *x_ftn_msgid, *my_ftn_addr;
 
 	debug(3,"putmessage from %s",ascfnode(fmsg->from,0x7f));
 	debug(3,"putmessage   to %s",ascfnode(fmsg->to,0x7f));
@@ -435,6 +438,20 @@
 			}
 
 			rfcheaders=0;
+			f_transit=1;
+			x_ftn_msgid=xstrcpy(hdr("X-FTN-MSGID",msg));
+			if (x_ftn_msgid != NULL && strlen(x_ftn_msgid)>0)
+			{
+			    p=x_ftn_msgid+1;
+			    while (*p != 0 && !isspace(*p)) p++;
+			    *p='\0';
+    			    my_ftn_addr=ascfnode(whoami->addr, 0x1f);
+			    if (!strcmp(x_ftn_msgid+1, my_ftn_addr))
+			    {
+				f_transit=0;
+			    }
+			}
+			if (x_ftn_msgid != NULL) free(x_ftn_msgid);
 			for (tmp=msg;tmp;tmp=tmp->next)
 			if ((needputrfc(tmp) == 1) &&
 			    ((strcasecmp(tmp->key,"Message-ID")) ||
